#include <vector>
#include <string>
#include <fstream>
#include <iostream>
#include "../../ae/ae/ae.h"
using namespace std;

//globally accessible variables
vector<float> EXTREM, fullcycles, halfcycles, P, V;
float tempnumber,RA,EXT,PRP,PP,VV;
int K,K1,N,NC,NCH,IPP,IPV,J,I;

//resize vectors
void resizevectors(void){
	extrema.resize(1);
	rawcycles.resize(1);
	EXTREM.resize(30001);
	P.resize(30001);
	V.resize(30001);
}//end resize vectors

//load extrema
void loadextrema(void){
	ifstream infile;
	infile.open("GAUSSOUT.EXT");
	K=0;
	while(!infile.eof()){
		infile >> tempnumber;
		if(!infile.eof()){
			EXTREM[K+1] = tempnumber;
			extrema[0].insert(extrema[0].end(),tempnumber);
			K++;
		}//end if
	}//end while
	infile.close();
}//end loadextrema

//float ABS(float in){
//	if(in < 0) return -in;
//	return in;
//}





//lutesrainflow
void lutesRNFLOW(void){
	/*      SUBROUTINE RNFLOW(EXT,IPV,V,P,K,NC,NCH,IPP,PRP)
	C
	C     SUBROUTINE TO PERFORM RAINFLOW CYCLE IDENTIFICATION
	C     AND COUNTING USING LUTES' ALGORITHM AS PROGRAMMED BY
	C     J. ZIMMERMAN ---- converted to c/c++ by Gregory Hildstrom
	C
	C EXT extrema under consideration
	C IPV 1 (EXT IS A PEAK) OR 0 (EXT IS A VALLEY)
	C V temp half-cycle valleys
	C P temp half-cycle peaks
	C K number of extrema
	C NC number of full cycles
	C NCH number of half cycles
	C IPP ????
	C PRP ????
	C I number of peaks
	C L number of valleys
	*/
	if(IPV > 0){

		PP=EXT;
		if(K!=1){
			for(I=2;I<=K;I++){
				if(P[K+1-I]>PP){
					K=K+2-I;
					P[K]=PP;
					IPV=0;
					return;
				}//end if P[K+1-I]>PP
				RA=ABS(P[K+1-I]-V[K+2-I]);
				if(RA!=0)fullcycles.insert(fullcycles.end(),RA);
			}//end for
			NC=NC+1;

			if(IPP!=0 && PRP <= PP){
				RA=ABS(PRP-V[1]);
				halfcycles.insert(halfcycles.end(),RA);
				IPP=0;
				NCH=NCH+1;
			}//end if IPP!=0 && PRP <= PP

			K=1;
		}//end if K!=1
		P[1]=PP;

		if(IPP!=0 && PRP<=P[1]){
			RA=ABS(PRP-V[1]);
			IPP=0;
			halfcycles.insert(halfcycles.end(),RA);
			NCH=NCH+1;
		}//end if IPP!=0 && PRP<=P[1]

		IPV=0;
		return;
	}//end if IPV > 0

	else{
		VV=EXT;
		for(I=1;I<=K;I++){
			if(VV>V[K+1-I]){
				K=K+2-I;
				V[K]=VV;
				IPV=1;
				return;
			}//end if VV>V[K+1-I]
			RA=ABS(P[K+1-I]-V[K+1-I]);

			if(I>=K && IPP!=1){
				halfcycles.insert(halfcycles.end(),RA);
				NCH=NCH+1;
				IPP=1;
				PRP=P[1];
				break;
			}//end if I>=K && IPP!=1

			NC=NC+1;
			if(RA!=0)fullcycles.insert(fullcycles.end(),RA);
		}//end for

		K=1;
		V[1]=VV;

		IPV=1;
		return;
	}//end else IPV <=0
}//end lutesrainflow








//perform lutes rainflow
void performlutesrainflow(void){
	//  INITIALIZE RAINFLOW PARAMETERS
	K1=K-1;
	N=1;
	NC=0;
	NCH=0;
	IPP=0;
	P[1]=0.0;
	V[1]=0.0;
	IPV=1;

	//  IDENTIFY CYCLES BY RAINFLOW
	for(J=1; J<=K1;J++){
		EXT=EXTREM[J];
		lutesRNFLOW();
	}//end for

	//  COMPLETE RAINFLOW COUNTING - determine half-cycles left over
	K1=N-IPV;

	for(J=1;J<=K1;J++){
		RA=ABS(P[J]-V[J]);
		halfcycles.insert(halfcycles.end(),RA);
		NCH=NCH+1;
	}//end for

	if(IPP!=0){
		RA=ABS(PRP-V[1]);
		halfcycles.insert(halfcycles.end(),RA);
		NCH=NCH+1;
	}//end if

	if(N!=1){
		for(J=2;J<=N;J++){
			RA=ABS(P[J-1]-V[J]);
			halfcycles.insert(halfcycles.end(),RA);
			NCH=NCH+1;
		}//end for
	}//end if
}//end perform lutes rainflow






vector<float> stdcycles;





//perform 1994 standarized rainflow attempt
//sucks from int journal of fatigue
void performstdrf(void){
	unsigned int i=0,j=0,k;
	float si,si1,si2,si3,ds1,ds2,ds3;

	i=0;
	while(extrema[0].size() >= 4 && i+3 < extrema[0].size()){
		//reading of points
		si=extrema[0][i];
		si1=extrema[0][i+1];
		si2=extrema[0][i+2];
		si3=extrema[0][i+3];

		//ranges calculation
		ds1=ABS(si1-si);
		ds2=ABS(si2-si1);
		ds3=ABS(si3-si2);

		//test
		if(ds2 == 0)
			extrema[0].erase(extrema[0].begin()+i+1);
		else if(ds2 <= ds1 && ds2 <= ds3){
			stdcycles.insert(stdcycles.end(),ds2);
			extrema[0].erase(extrema[0].begin()+i+1);
			extrema[0].erase(extrema[0].begin()+i+1);
		}//end if
		else
			i++;
	}//end while
	
	//residue
	cout << "extrema[0].size(): " << extrema[0].size() << endl;

	//duplicate residue and run through same algorithm
	unsigned int origsize = extrema[0].size();
	for(unsigned int r=0;r<origsize;r++)
		extrema[0].insert(extrema[0].end(),extrema[0][r]);
	cout << "extrema[0].size(): " << extrema[0].size() << endl;


	i=0;
	while(extrema[0].size() >= 4 && i+3 < extrema[0].size()){
		//reading of points
		si=extrema[0][i];
		si1=extrema[0][i+1];
		si2=extrema[0][i+2];
		si3=extrema[0][i+3];

		//ranges calculation
		ds1=ABS(si1-si);
		ds2=ABS(si2-si1);
		ds3=ABS(si3-si2);

		//test
		if(ds2 == 0)
			extrema[0].erase(extrema[0].begin()+i+1);
		else if(ds2 <= ds1 && ds2 <= ds3){
			stdcycles.insert(stdcycles.end(),ds2);
			extrema[0].erase(extrema[0].begin()+i+1);
			extrema[0].erase(extrema[0].begin()+i+1);
		}//end if
		else
			i++;
	}//end while
	
	//residue
	cout << "extrema[0].size(): " << extrema[0].size() << endl;


}//end performstdrf





//outputstdcycles
void outputstdcycles(void){
	ofstream outfile;
	outfile.open("fcSTD.csv",ios::trunc);
	for(unsigned int i=0; i < stdcycles.size(); i++){
		outfile << stdcycles[i] << endl;
	}//end for
	outfile.close();
}//end outputstdcycles





//outputfullcycles
void outputfullcycles(void){
	ofstream outfile;
	outfile.open("fcLutes.csv",ios::trunc);
	for(unsigned int i=1; i < fullcycles.size(); i++){
		outfile << fullcycles[i] << endl;
	}//end for
	outfile.close();
}//end outputfullcycles






//outputhalfcycles
void outputhalfcycles(void){
	ofstream outfile;
	outfile.open("hcLutes.csv",ios::trunc);
	for(unsigned int i=1; i < halfcycles.size(); i++){
		outfile << halfcycles[i] << endl;
	}//end for
	outfile.close();
}//end outputhalfcycles






//outputrawcycles
void outputrawcycles(void){
	ofstream outfile;
	outfile.open("fcASTM.csv",ios::trunc);
	for(unsigned int i=0; i < rawcycles[0].size(); i++){
		outfile << rawcycles[0][i] << endl;
	}//end for
	outfile.close();
}//end outputrawcycles



int main(){

	resizevectors();

	loadextrema();
	cout << "K: " << K << endl;

	performlutesrainflow();
	cout << "NC: " << NC << endl;
	cout << "fullcycles.size(): " << fullcycles.size() << endl;
	cout << "NCH: " << NCH << endl;
	cout << "halfcycles.size(): " << halfcycles.size() << endl;

	performrainflow(0);
	cout << "rawcycles[0].size(): " << rawcycles[0].size() << endl;

	performstdrf();
	cout << "stdcycles.size(): " << stdcycles.size() << endl;

	outputfullcycles();
	outputhalfcycles();
	outputrawcycles();
	outputstdcycles();

	system("pause");
	return 0;
}//end main


