#ifndef slae_h
#define slae_h

#include<iostream>//for cout
#include<fstream>//for file i/o
#include<vector>//for STL vector
#include<string>//for string
#include<math.h>//for math functions
#include<time.h>//for time functions
using namespace std;//using the standard namespace




//global variables - user defined
class statslogline{//stores one line from statslog.csv file
public:
	string filename;
	int numchan;
	int realnumchan;
	int virtualnumchan;
	float scanrate;
	string analysisdate;
	int analysistime;
	unsigned int numscans;
	float seconds;
	string version;
	int fftsize;
	int wavechannel;
	float cutofffrequency;
	int channel;
	float cal;
	float scalefactor;
	float offset;
	string channelname;

	float mean;
	float max;
	float min;
	float variance;
	float skewness;
	float kurtosis;

	float meanlp;
	float maxlp;
	float minlp;
	float variancelp;
	float skewnesslp;
	float kurtosislp;

	float meanhp;
	float maxhp;
	float minhp;
	float variancehp;
	float skewnesshp;
	float kurtosishp;
	
	unsigned int numextrema;
	unsigned int numcycles;
	float damage;
	float meancycle;
	float maxcycle;
	float mincycle;
	float variancecycles;
	float skewnesscycles;
	float kurtosiscycles;

	unsigned int rawmaxnumberofweibullamplitudes;
	float rawmaxamplitudemean;
	float rawmaxamplitudemax;
	float rawmaxamplitudemin;
	float rawmaxamplitudevariance;
	float rawmaxamplitudeskew;
	float rawmaxamplitudekurtosis;
	float rawmaxlrbeta;
	float rawmaxlryint;
	float rawmaxlrcharval;
	float rawmaxlrcorrelation;
	float rawmaxmmbeta;
	float rawmaxmmyint;
	float rawmaxmmcharval;

	unsigned int rawminnumberofweibullamplitudes;
	float rawminamplitudemean;
	float rawminamplitudemax;
	float rawminamplitudemin;
	float rawminamplitudevariance;
	float rawminamplitudeskew;
	float rawminamplitudekurtosis;
	float rawminlrbeta;
	float rawminlryint;
	float rawminlrcharval;
	float rawminlrcorrelation;
	float rawminmmbeta;
	float rawminmmyint;
	float rawminmmcharval;

	unsigned int rawp2pnumberofweibullamplitudes;
	float rawp2pamplitudemean;
	float rawp2pamplitudemax;
	float rawp2pamplitudemin;
	float rawp2pamplitudevariance;
	float rawp2pamplitudeskew;
	float rawp2pamplitudekurtosis;
	float rawp2plrbeta;
	float rawp2plryint;
	float rawp2plrcharval;
	float rawp2plrcorrelation;
	float rawp2pmmbeta;
	float rawp2pmmyint;
	float rawp2pmmcharval;

	unsigned int lpmaxnumberofweibullamplitudes;
	float lpmaxamplitudemean;
	float lpmaxamplitudemax;
	float lpmaxamplitudemin;
	float lpmaxamplitudevariance;
	float lpmaxamplitudeskew;
	float lpmaxamplitudekurtosis;
	float lpmaxlrbeta;
	float lpmaxlryint;
	float lpmaxlrcharval;
	float lpmaxlrcorrelation;
	float lpmaxmmbeta;
	float lpmaxmmyint;
	float lpmaxmmcharval;

	unsigned int lpminnumberofweibullamplitudes;
	float lpminamplitudemean;
	float lpminamplitudemax;
	float lpminamplitudemin;
	float lpminamplitudevariance;
	float lpminamplitudeskew;
	float lpminamplitudekurtosis;
	float lpminlrbeta;
	float lpminlryint;
	float lpminlrcharval;
	float lpminlrcorrelation;
	float lpminmmbeta;
	float lpminmmyint;
	float lpminmmcharval;

	unsigned int lpp2pnumberofweibullamplitudes;
	float lpp2pamplitudemean;
	float lpp2pamplitudemax;
	float lpp2pamplitudemin;
	float lpp2pamplitudevariance;
	float lpp2pamplitudeskew;
	float lpp2pamplitudekurtosis;
	float lpp2plrbeta;
	float lpp2plryint;
	float lpp2plrcharval;
	float lpp2plrcorrelation;
	float lpp2pmmbeta;
	float lpp2pmmyint;
	float lpp2pmmcharval;

	unsigned int hpmaxnumberofweibullamplitudes;
	float hpmaxamplitudemean;
	float hpmaxamplitudemax;
	float hpmaxamplitudemin;
	float hpmaxamplitudevariance;
	float hpmaxamplitudeskew;
	float hpmaxamplitudekurtosis;
	float hpmaxlrbeta;
	float hpmaxlryint;
	float hpmaxlrcharval;
	float hpmaxlrcorrelation;
	float hpmaxmmbeta;
	float hpmaxmmyint;
	float hpmaxmmcharval;

	unsigned int hpminnumberofweibullamplitudes;
	float hpminamplitudemean;
	float hpminamplitudemax;
	float hpminamplitudemin;
	float hpminamplitudevariance;
	float hpminamplitudeskew;
	float hpminamplitudekurtosis;
	float hpminlrbeta;
	float hpminlryint;
	float hpminlrcharval;
	float hpminlrcorrelation;
	float hpminmmbeta;
	float hpminmmyint;
	float hpminmmcharval;

	unsigned int hpp2pnumberofweibullamplitudes;
	float hpp2pamplitudemean;
	float hpp2pamplitudemax;
	float hpp2pamplitudemin;
	float hpp2pamplitudevariance;
	float hpp2pamplitudeskew;
	float hpp2pamplitudekurtosis;
	float hpp2plrbeta;
	float hpp2plryint;
	float hpp2plrcharval;
	float hpp2plrcorrelation;
	float hpp2pmmbeta;
	float hpp2pmmyint;
	float hpp2pmmcharval;

	float psdpeakfrequency;

	int performrainflowanalysis;
	int performmmmanalysis;
	int performpsdanalysis;
	int performraoanalysis;
	int performweibullanalysis;
	float emptyscalevalue;
	float yellowlinevalue;
	float redlinevalue;
	float fullscalevalue;
	float piersidezerovalue;
	string channelinformation;
	string prescalefactorunits;
	string postscalefactorunits;
	string channellocation;

	int zerovarianceflag;
	int emptyscaleflag;
	int yellowlineflag;
	int redlineflag;
	int fullscaleflag;
	int hplpvarianceflag;
	int hplpmaxflag;

	float psd99pctfrequency;

	float modelscaleratio;
	float fullscanrate;
	float fullseconds;

	void readline(ifstream& inputfile){//reads one line from statslog.csv file
		if(inputfile.eof()) return;

		string temp;

		getline(inputfile, temp, ','); filename = temp; temp.clear();
		if(inputfile.eof()) return;
		getline(inputfile, temp, ','); numchan = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); virtualnumchan = atoi(temp.data()); temp.clear();
		realnumchan = numchan-virtualnumchan;
		getline(inputfile, temp, ','); scanrate = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); analysisdate = temp; temp.clear();
		getline(inputfile, temp, ','); analysistime = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); numscans = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); seconds = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); version = temp; temp.clear();
		getline(inputfile, temp, ','); fftsize = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); wavechannel = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); cutofffrequency = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); channel = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); cal = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); scalefactor = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); offset = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); channelname = temp; temp.clear();

		getline(inputfile, temp, ','); mean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); max = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); min = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); variance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); skewness = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); kurtosis = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); meanlp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); maxlp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); minlp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); variancelp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); skewnesslp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); kurtosislp = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); meanhp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); maxhp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); minhp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); variancehp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); skewnesshp = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); kurtosishp = (float)atof(temp.data()); temp.clear();
		
		getline(inputfile, temp, ','); numextrema = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); numcycles = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); damage = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); meancycle = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); maxcycle = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); mincycle = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); variancecycles = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); skewnesscycles = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); kurtosiscycles = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); rawmaxnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawmaxmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); rawminnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawminmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); rawp2pnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2plrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2plryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2plrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2plrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); rawp2pmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); lpmaxnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpmaxmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); lpminnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpminmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); lpp2pnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2plrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2plryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2plrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2plrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); lpp2pmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); hpmaxnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpmaxmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); hpminnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminlrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminlryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminlrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminlrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpminmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); hpp2pnumberofweibullamplitudes = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudemean = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudemax = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudemin = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudevariance = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudeskew = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pamplitudekurtosis = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2plrbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2plryint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2plrcharval = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2plrcorrelation = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pmmbeta = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pmmyint = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hpp2pmmcharval = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); psdpeakfrequency = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); performrainflowanalysis = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); performmmmanalysis = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); performpsdanalysis = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); performraoanalysis = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); performweibullanalysis = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); emptyscalevalue = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); yellowlinevalue = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); redlinevalue = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); fullscalevalue = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); piersidezerovalue = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); channelinformation = temp; temp.clear();
		getline(inputfile, temp, ','); prescalefactorunits = temp; temp.clear();
		getline(inputfile, temp, ','); postscalefactorunits = temp; temp.clear();
		getline(inputfile, temp, ','); channellocation = temp; temp.clear();

		getline(inputfile, temp, ','); zerovarianceflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); emptyscaleflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); yellowlineflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); redlineflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); fullscaleflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hplpvarianceflag = atoi(temp.data()); temp.clear();
		getline(inputfile, temp, ','); hplpmaxflag = atoi(temp.data()); temp.clear();

		getline(inputfile, temp, ','); psd99pctfrequency = (float)atof(temp.data()); temp.clear();

		getline(inputfile, temp, ','); modelscaleratio = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, ','); fullscanrate = (float)atof(temp.data()); temp.clear();
		getline(inputfile, temp, '\n'); fullseconds = (float)atof(temp.data()); temp.clear();
	}//end readline
};//end class statslogline


static vector<statslogline> statslog;//vector/array of statslog lines; stores multiple lines


//this function reads the mmm stats and rainflow damage stats and weibull stats
//from a statslog.csv file
static void readstatslog(string filename){
	time_t analysistime;
	time(&analysistime);
	string header;

	//check input file size
	long filesize;
	ifstream file (filename.data(), ios::in|ios::binary);
	file.seekg (0, ios::end);
	filesize = file.tellg();
	file.seekg (0, ios::beg);

	//read header line
	getline(file,header,'\n');

	//temporary statslog line
	statslogline sll;

	//read every line and store it in the statslog vector
	while(!file.eof()){
		sll.readline(file);
		statslog.insert(statslog.end(),sll);
	}//end while
	statslog.resize(statslog.size()-1);

	file.close();
}//end readstatslog

//stores every unique scanrate and numchan
static vector<float> scanrates;
static vector<int> numchannels;

//counts unique scanrates and numchannels
static void determinescanratesandchannels(void){
	scanrates.insert(scanrates.end(),statslog[0].scanrate);
	numchannels.insert(numchannels.end(),statslog[0].numchan);
	float tempscanrate;
	bool found;
	for(unsigned int i=1; i < statslog.size(); i++){
		tempscanrate = statslog[i].scanrate;
		found = false;
		for(unsigned int j=0; j < scanrates.size(); j++){
			if(tempscanrate == scanrates[j]) found = true;
		}//end for
		if(!found){
			scanrates.insert(scanrates.end(),tempscanrate);
			numchannels.insert(numchannels.end(),statslog[i].numchan);
		}//end if
	}//end for
}//end determinescanrates





#endif

